from .url_decoder import url_decode
class RequestException(Exception):
	def __init__(self, msg):
		self.value=msg
class MethodError(Exception):
	def __init__(self, method):
		self.value=method

class request:
	_request_=None
	method='POST'
	def __init__(self):
		if self._request_==None:
			raise RequestException('do not try to get form values outside http request')
	def form_action_post(self):
		try:
			x=str(self._request_).split('\n')[-1]
			i=x.split('&')
			form_value={}
			for one in i:
				b=one.split('=')
				key=url_decode(b[0])
				value=url_decode(b[1])
				form_value[key]=value
		except IndexError:
			pass
		return form_value
	def form_action_get(self):
		try:
			hdr=self._request_.split('\n')[0].split()[1]
		except IndexError:
			hdr=''
		try:
			form_=hdr.split('/?')[1]
		except IndexError:
			form_=''
		try:
			form_=url_decode(form_)
			form_values={}
			sp=form_.split('&')
			for one in sp:
				two=one.split('=')
				key=two[0]
				value=two[1]
				form_values[key]=value
		except IndexError:
			pass
		return form_values
	def form(self):
		if str(self.method).upper()=='POST':
			return self.form_action_post()
		elif str(self.method).upper()=='GET':
			return self.form_action_get()
		else:
			raise MethodError(f'unknown method -> {self.method}')